<template>
  <div>
    <div class="flex flex-no-wrap bg-gray-200 text-gray-900 h-screen">
      <div
        class="w-64 absolute sm:relative bg-gray-800 shadow md:h-auto flex-col justify-between hidden sm:flex"
      >
        <Sidebar />
      </div>

      <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
        <h1
          class="my-8 text-center text-4xl tracking-tight font-extrabold text-gray-900 sm:text-5xl md:text-6xl"
        >
          Administration
        </h1>
        <div class="flex flex-wrap -mx-3 mb-20">
          <div class="w-1/2 xl:w-1/4 px-3">
            <div
              class="w-full bg-white border text-blue-400 rounded-lg flex items-center p-6 mb-6 xl:mb-0"
            >
              <div class="w-16 h-16 fill-current mr-8 hidden lg:block">
                <font-awesome-icon icon="gamepad" size="4x" />
              </div>

              <div class="text-gray-700">
                <p class="font-semibold text-3xl">{{ nbGames }}</p>
                <p>Jeux</p>
              </div>
            </div>
          </div>

          <div class="w-1/2 xl:w-1/4 px-3">
            <div
              class="w-full bg-white border text-blue-400 rounded-lg flex items-center p-6 mb-6 xl:mb-0"
            >
              <div class="w-16 h-16 fill-current mr-8 hidden lg:block">
                <font-awesome-icon icon="puzzle-piece" size="4x" />
              </div>

              <div class="text-gray-700">
                <p class="font-semibold text-3xl">{{ nbStudios }}</p>
                <p>Studios</p>
              </div>
            </div>
          </div>

          <div class="w-1/2 xl:w-1/4 px-3">
            <div
              class="w-full bg-white border text-blue-400 rounded-lg flex items-center p-6"
            >
              <div class="w-16 h-16 fill-current mr-8 hidden lg:block">
                <font-awesome-icon icon="heart" size="4x" />
              </div>

              <div class="text-gray-700">
                <p class="font-semibold text-3xl">{{ nbLikes }}</p>
                <p>Likes</p>
              </div>
            </div>
          </div>

          <div class="w-1/2 xl:w-1/4 px-3">
            <div
              class="w-full bg-white border text-blue-400 rounded-lg flex items-center p-6"
            >
              <div class="w-16 h-16 fill-current mr-8 hidden lg:block">
                <font-awesome-icon icon="comment" size="4x" />
              </div>

              <div class="text-gray-700">
                <p class="font-semibold text-3xl">{{ nbComments }}</p>
                <p>Commentaires</p>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Sidebar from "./Sidebar"

export default {
  name: "Home",
  components: {
    Sidebar
  },
  data() {
    return {
      nbGames: 0,
      nbStudios: 0,
      nbLikes: 0,
      nbComments: 0,
      urlGetGames: `https://${window.location.hostname}:8443/games`,
      urlGetStudios: `https://${window.location.hostname}:8443/studios`,
      urlGetLikes: `https://${window.location.hostname}:8443/like`,
      urlGetComments: `https://${window.location.hostname}:8443/comment`
    }
  },
  inject: ["user", "createAlert"],
  beforeMount() {
    const headers = {
      Accept: "application/json",
      "Content-Type": "application/json",
      Authorization: "Bearer " + this.user.token
    }

    fetch(this.urlGetGames, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.nbGames = data.length
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })

    fetch(this.urlGetStudios, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.nbStudios = data.length
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })

    fetch(this.urlGetLikes, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.nbLikes = data.length
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })

    fetch(this.urlGetComments, {
      headers,
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        this.nbComments = data.length
      })
      .catch(() => {
        this.$router.push("/404")
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  }
}
</script>
